; 
    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    include \masm32\macros\macros.asm
; 
    .data
    .code
; 
start: 
; 
    call  delay                 ; calibrate
    REPEAT 100
        invoke GetTickCount
        mov   esi, eax
        mov   ecx, 1000
        .REPEAT
            call  delay
        .UNTILCXZ
        invoke GetTickCount
        sub   eax, esi
        print ustr$(eax),13,10
    ENDM

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 

; 
; This proc self-calibrates on the first call and thereafter
; delays for ~100 microseconds before returning.
; 
;
delay proc uses eax ebx ecx edx edi esi

    GLOBAL delayLoops dd 0

    .IF delayLoops
        mov   ecx,delayLoops
        call  delayloop
    .ELSE
        ; ----------------------------------------------
        ; Determine the loop count for a 100 ms delay.
        ; ----------------------------------------------
        mov   ebx, 1000         ; load initial loop count
        mov   edi, 80000h       ; load initial increment
        .REPEAT
            .REPEAT
                ; ------------------------------------------
                ; Sync with the timer to improve accuracy.
                ; ------------------------------------------
                invoke GetTickCount
                mov   esi,eax
                .REPEAT
                    invoke GetTickCount
                .UNTIL eax > esi

                add   ebx, edi  ; add increment to count

                print "+"

                invoke GetTickCount
                mov   esi, eax
                add   esi, 97   ; reduced to allow for variation

                mov   ecx, ebx
                call  delayloop

                invoke GetTickCount
            .UNTIL eax > esi    ; until delay is > 97 ms

            print ustr$(ebx),13,10
            print uhex$(edi),13,10

            sub   ebx, edi      ; subtract increment from count
            sub   ebx, 100
            shr   edi, 4        ; decrease increment
        .UNTIL edi < 80h        ; until increment < 80h
        
        print ustr$(ebx),13,10

        ; ----------------------------------------------------
        ; Adjust the loop count for a 100 microsecond delay.
        ; ----------------------------------------------------
        xor   edx, edx
        mov   eax, ebx
        mov   ebx, 1000         ; <== modify to adjust delay
        div   ebx
        mov   delayLoops, eax

        print ustr$(eax),13,10,13,10

    .ENDIF
    ret
    
delay endp

delayloop proc uses edi
    .REPEAT                 ; run delay loop
        REPEAT 3
            xor   edx, edx
            xor   eax, eax
            mov   edi, 1
            div   edi
        ENDM
    .UNTILCXZ
    ret
delayloop endp

; 
end start
